

#include "banca.h"

/**
 * Constructor por defecto
 */
banca::banca()
  :  _casasDisponibles ( 1000 ),
     _hotelesDisponibles ( 1000 )
{
  //No se hace nada
}

/**
 * Constructor explcito.
 */
banca::banca ( int casas, int hoteles )
  : _casasDisponibles ( casas ),
    _hotelesDisponibles ( hoteles )
{
  //No se hace nada
}

/**
 * Copy constructor
 */
banca::banca (const banca& right)
{
  _casasDisponibles	= right._casasDisponibles;
  _hotelesDisponibles	= right._hotelesDisponibles;
}


/**
 * Operador de asignacin
 */
banca& banca::operator= (const banca& right)
{
  _casasDisponibles	= right._casasDisponibles;
  _hotelesDisponibles	= right._hotelesDisponibles;
  return ( *this );
}

/**
 * Destructor
 */
banca::~banca ()
{
  // no se hace nada
}

/**
 *  Opreador << sobrecargado para mostrar los datos de inters de la banca.
 */
ostream& operator<< ( ostream &os, banca* b )
{
  string aux = "";  
  char numAlpha[10];
  sprintf( numAlpha, "%d", b->get_casasDisponibles() );       
  aux = "Nmero de casas disponibles " + string ( numAlpha ) + "\n";
  char numAlphaHoteles[5];
  sprintf( numAlphaHoteles, "%d", b->get_hotelesDisponibles() );       
  aux += "Nmero de hoteles disponibles " + string ( numAlphaHoteles ) + "\n";
  os << aux;  
  return os;
}
