/** 
 * Libreria que incluye funciones útiles para el tratamiento de cadenas
 * de caracteres 
 * 
 * Autor: Javier Aragón Zabalegui
 * Contacto: 100039831@alumnos.uc3m.es
 * Versión: 1.5
 */


#include <string>
#include <iostream>
using namespace std;

#include <readline/readline.h>

/**********METODOS UTILES PARA EL TRATAMIENTO DE CADENAS**************/

/** 
 * Duplica una cadena de caracteres (s). Realiza la reserva de memoria 
 */
char * dupstr (char *s);

/**
 * Elimina espacios del principio y el final de un STRING. Devuelve un
 * puntero a la cadena. 
 * IN: Cadena sin limpiar
 * OUT: Cadena sin espacios 
 */
char *stripwhite (char *string);

/** 
 * Elimina espacios del principio y el final de un STRING. Devuelve la cadena
 * sin espacios
 * IN: Cadena sin limpiar
 * OUT: Cadena sin espacios 
 */
string stripwhite_st (string linea);

/**
 * Busca la siguiente palabra en una cadena de caracteres. Las palabras 
 * están separadas por el separador. 
 */
char *buscar_palabra ( char *linea, char separador, int numero );

/** 
 * Dentro de un string buscará el substring que está comprendido entre 'pos' y el 'delimitador' 
 */
string obtener_substring_delimitado_st ( string linea, string delimitador, string::size_type pos, string::size_type &pos_despues );

/** Dentro de un string buscar el substring que está comprendido entre 'pos' y el 'delimitador' 
 *  El resultado debe ser un valor de tipo entero 
 */
int obtener_substring_delimitado_int ( string linea, string delimitador, string::size_type pos, string::size_type &pos_despues );

/**
 * Dentro de un string buscará el substring que está comprendido entre 'pos' y el 'delimitador' 
 * El resultado debe ser un valor de tipo entero largo (long) 
 */
int obtener_substring_delimitado_long ( string linea, string delimitador, string::size_type pos, string::size_type &pos_despues );

/** 
 * Centra una cadena dentro de un ancho específico, colocando al inicio y al final el separador 
 * indicado, y repartiendo la cadena entre el maxLineas deseado 
 */
string centrarCadena ( string original, int ancho, int maxLineas, string separador );

/** Busca y devuelve palabras completas dentro de un string, delimitado por dos valores
    numericos, que le indican cual es el inicio donde debe empezar a buscar, y la longitud
    máxima del total de las palabras. 
*/
string buscarPalabraCompleta ( string palabra, int inicio, int max );

/**
 * Método que recoge una cadena de caracteres y la abrevia cogiendo los n primeros caracteres
 * o los n caracteres que siguen a un espacio.
 *	Ejemplos:
 *		Azul Marino --2carac--> AM
 *		Azul ---------2carac--> Az
 */
string abreviar ( string original, int max );
