
#include "carcel.h"

// Constructor por defecto
carcel::carcel ()
  : casilla (),
    _maxTurnos ( 3 ),
    _multa (5000)
{
  // No se hace nada!
}

// constructor explcito
carcel::carcel ( int numero, string nombre, string nombreCorto, int maxTurnos, long multa )
  : casilla ( numero, nombre, nombreCorto ),
    _maxTurnos ( maxTurnos ),
    _multa ( multa )
{
  // No se hace nada!
}
 
// Copy constructor
carcel::carcel (const carcel& right):casilla ( right )
{
  _maxTurnos 	= right._maxTurnos;  
  _multa        = right._multa;
}

// Operator de asignacin
carcel& carcel::operator= (const carcel& right)
{  
  casilla::operator= ( right );
  _maxTurnos	= right.get_maxTurnos ();
  _multa        = right.get_multa();
  return ( *this );
}

// Destructor
carcel::~carcel ()
{
  // No se hace nada!
}

/**
 * Polimorfismo de la clase casilla. En este caso no se realiza ninguna accin sobre
 * un jugador al caer sobre la crcel.
 */
int carcel::accion ( jugador* player )
{  
  cout << "Pasas de visita por la crcel" << endl;
  return 0;
}

/**
 * Mtodo que libera a un jugador de la crcel. Para ello debe indicar al jugador que no 
 * debe permanecer encarcelado ningn turno ms.
 */
void carcel::desencarcelar ( jugador* j )
{
  //Establece los turnos encarcelados restantes a 0
  j->set_turnosEncarcelado ( 0 );
  return;
}

/**
 * Mtodo que restar al jugador la cantidad de dinero que indica la multa, y le liberar
 * de la crcel. Si no tiene dinero le informar de que deber reunir el dinero antes del
 * final de su turno.
 */
int carcel::desencarcelarPagando ( jugador* j )
{
  //Si tiene dinero suficiente, se paga y se desencarcela al jugador
  int ok = 0;
  if ( j->get_dinero_total() >= get_multa() )
    {
      j->pagar( get_multa() );
      desencarcelar ( j );
      ok = 0;
    }
  //Si no tiene dinero, se ofrece la posibilidad de salir aun quedando en quiebra
  else
    {
      cerr << "No tiene dinero suficiente para pagar la multa. Desea pagar an quedando en una situacin de quiebra? (Tendr hasta final de su turno para conseguir dinero) (s/N)";
      cin.clear();
      cin.ignore( 2000, '\n' );
      char opcion = cin.get();
      if ( toupper ( opcion ) == 'S' )
	{
	  j->pagar( get_multa() );
	  desencarcelar ( j );
	  ok = -1;
	}
      else
	ok = 0;
    }
  return ( ok );
}
