

#include "casilla.h"

// Constructor por defecto
casilla::casilla ()
  : _numero ( 0 ),
    _nombre ("no hay datos"),
    _nombreCorto ( "S/D" )
{
  // No se hace nada!
}

// constructor explcito
casilla::casilla ( int numero, string nombre, string nombreCorto )
  : _numero ( numero ),
    _nombre ( nombre ),
    _nombreCorto ( nombreCorto )
{
  // No se hace nada!
}
 
// Copy constructor
casilla::casilla (const casilla& right)
{
  _numero	= right._numero;
  _nombre	= right._nombre;
  _nombreCorto	= right._nombreCorto;
}

/**
 * Sobrecarga de operadores 
 */
// Operator de asignacin
casilla& casilla::operator= (const casilla& right)
{
  _numero	= right.get_numero ();
  _nombre	= right.get_nombre ();
  _nombreCorto	= right.get_nombreCorto ();
  return ( *this );
}

// Operador de igualdad
bool casilla::operator== ( const casilla& c )
{
  if ( c.get_numero() == get_numero() )
    return true;
  else
    return false;
}

// Operador de insercin
ostream& operator<< (ostream &os, casilla *c)
{  
  string aux =  c->mostrar ();
  os << aux;
  return os;
  //...Aqu como se muestra una casilla
}

// Operador de extraccin
istream& operator>> (istream& is, const casilla& c)
{
  //...Aqu como se recoge datos de una casilla
}

// Destructor
casilla::~casilla ()
{
  // No se hace nada!
}

/**
 * Mtodos virtuales: Polimorfismo
 */

/**
 * Mtodo que devuelve en una cadena de caracteres toda la informacin necesaria, con un
 * formato preparado para mostrarse por pantalle,  de una casilla genrica, que 
 * incluye:
 *    -Nombre
 *    -Nmero de casilla
 * En las clases derivadas ser necesario detallar con cuidado esta informacin, ya que
 * existe informacin muy importante..
 */
string casilla::mostrar ()
{
  const int ancho = 42;
  string aux =  " __________________________________________\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += centrarCadena ( get_nombre(), ancho + 2, 2, "|" );
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  char numAlpha[30];
  sprintf ( numAlpha, "%d", get_numero() );
  if ( get_numero() >= 10 )
    aux += "|                                       " + string ( numAlpha )  + " |\n";
  else
    aux += "|                                        " + string ( numAlpha )  + " |\n";    
  aux += "|__________________________________________|\n";
  return aux;
}


/**
 * Mtodo que efectua la accin propia de cada casilla. Es un mtodo virtual porque cada tipo de
 * casilla tiene una accin propia que debe ejecutar.
 * En el caso de la casilla genrica no se lleva a cabo ninguna accin.
 */
int casilla::accion ( jugador* player )
{
  cout << "Un alto en el camino. Has cado en una casilla libre de gastos" << endl;
  return 0;
}


/** 
 * MTODOS PARA DIBUJAR LAS CASILLAS 
 */


/**
 * Mtodo que dibuja la fila indicada de la casilla correspondiente (en las filas de arriba y abajo del tablero).
 * Se indicar la fila que se tiene que dibujar y el ancho con el que se tiene que pintar. Como resultado se
 * devolver una cadena de caracteres.
 */
string casilla::dibujarCasillaHorizontal ( int fila, int anchoCasilla )
{
  string sFila;  
  
  switch ( fila )
    {
    case 0:
      sFila = " ";				//Primer caracter
      for ( int i = 1; i < anchoCasilla ; i++ )
	sFila += "_";
      break;

    case 1:					//numero + (monopolio, flecha o nada)
      {
	char numAlpha[10];
	sprintf( numAlpha, "%d", get_numero() );
	sFila = string ( numAlpha );       
	while ( sFila.size() <= ( anchoCasilla - 2 ) )
	  sFila += " ";      
	sFila += "|";
	break;
      }

    case 2:
      sFila = get_nombreCorto();
      while ( sFila.size() <= ( anchoCasilla - 2 ) )
	sFila += " ";      
      sFila += "|";
      break;
      
    case 3:					//COMPROBAR SI ESTAN LOS JUGADORES 1, 2 y 3
      {
	int i = 0;
	string aux = "";	
	int numJugadores = estaJugador.size ();
	while ( ( numJugadores > 0 ) && ( i < numJugadores ) && ( i < 3 ) )
	  {	    
	    string color = estaJugador[i]->get_color();
	    string colorAbreviado = color.substr(0,2);
	    transform (colorAbreviado.begin(), colorAbreviado.end(), colorAbreviado.begin(), (int(*)(int))toupper);
	    aux += colorAbreviado;
	    i++;
	    if ( i < 3 ) 
	      aux += " ";
	  }	
	while (aux.size() < anchoCasilla - 1 )
	  aux += " ";
	sFila += aux + '|';
	break;
      }

    case 4:					//COMPROBAR SI ESTAN LOS JUGADORES 4, 5 y 6      
      {
	int i = 3;
	string aux = "";	
	int numJugadores = estaJugador.size ();
	while ( ( numJugadores > 3 ) && ( i < numJugadores ) && ( i < 6 ) )
	  {	   
	    string color = estaJugador[i]->get_color();
	    aux += color.substr(0,2);
	    i++;
	    if ( i < 6 ) 
	      aux += " ";	
	  }	
	while (aux.size() < anchoCasilla - 1 )
	  aux += " ";
	sFila += aux + '|';
	break;
      }

    case 5:
      while ( sFila.size() <= ( anchoCasilla - 2 ) )
	sFila += "_";	 	
      sFila += "|";
      break;    
    }
  
  return sFila;
}

/**
 * Mtodo que dibuja la fila indicada de la casilla correspondiente (en las columnas derecha e izquierda del tablero).
 * Se indicar la fila que se tiene que dibujar y el ancho con el que se tiene que pintar. Como resultado se
 * devolver una cadena de caracteres.
 */
string casilla::dibujarCasillaVertical ( int fila, int anchoCasilla )
{
  string sFila;  
  int const MaxCasillasAncho = 13;
  int const MaxCasillasAlto = 8;
  
  sFila = "|";
  switch ( fila )
    {    
      
    case 0:					//numero + posibles jugadores 1, 2 y 3
      {
	
	string aux = "";
	char numAlpha[30];
	sprintf( numAlpha, "%d", get_numero() );
	aux += string ( numAlpha );
	if ( get_numero() < 10 )
	  aux +=  "     ";
	else aux +=  "    ";
	int i = 0;
	int numJugadores = estaJugador.size ();
	while ( ( numJugadores > 0 ) && ( i < numJugadores ) && ( i < 3 ) )
	  {
	    string color = estaJugador[i]->get_color();
	    string colorAbreviado = color.substr(0,2);
	    transform (colorAbreviado.begin(), colorAbreviado.end(), colorAbreviado.begin(), (int(*)(int))toupper);
	    aux += colorAbreviado;	    	    
	    i++;
	    if ( i < 3 ) 
	      aux += " ";	
	  }
	while (aux.size() < anchoCasilla - 1 )
	  aux += " ";
	sFila += aux + '|';      
	break;
      }
    case 1:
      {
	string aux = "";
	aux += get_nombreCorto();      
	while ( aux.size() < 6 ) aux += " ";
	int i = 3;	
	int numJugadores = estaJugador.size ();
	while ( ( numJugadores > 3 ) && ( i < numJugadores ) && ( i < 6 ) )
	  {
	    string color = estaJugador[i]->get_color();
	    aux += color.substr(0,2);
	    i++;
	    if ( i < 6 ) 
	      aux += " ";	
	  }	
	while (aux.size() < anchoCasilla - 1 )
	  aux += " ";
	sFila += aux + '|';
	break;
      }
      
    case 2:      
      while ( sFila.size() <= ( anchoCasilla - 1) )
	sFila += "_";      
      sFila += "|";
      break;  
      
      return sFila;
    }
}

/**
 * Mtodo que devuelve una cadena de caracteres que representa como es la casilla en su 
 * imgen en el tablero, indicando aquellos datos de inters para un jugador que caiga 
 * sobre ella:
 *  -Numero
 *  -Nombre
 */
string casilla::dibujarCasillaEnTablero ()
{
  const int anchoDibujado = 27;
  string aux;
  aux = " ___________________________\n";
  aux +="|                           |\n";
  aux +="|                           |\n";

  /* Linea del nombre */
  string linea = "|";
  string nombre = get_nombre ();
  aux += centrarCadena ( nombre, anchoDibujado + 2, 2, "|" );

  aux +="|                           |\n";
  /* Informacin sobre la edificacin en la calle */
  aux +="|                           |\n";
  aux +="|                           |\n";

  /* Precio de la propiedad */
  aux +="|                           |\n";

  /* Nmero de casilla */
  int numero = get_numero();
  aux +="|                         ";
  if ( numero < 10 )
    aux += " ";
  char numAlpha[10];
  sprintf( numAlpha, "%d", numero );
  aux += numAlpha;
  aux += "|\n";
  /* Base del rectngulo */
  aux +="|___________________________|\n";
  return aux;
}

/**
 * Devuelve la informacin de la casilla en modo texto para mostrar por pantalla la informacin
 * en forma de tabla. 
 */
string casilla::leyendaCasilla ( int num, int nombreCorto, int tipo, int nombre, int estado )
{
  string aux;
  int numeroCasilla = get_numero();
  char numAlpha[30];
  sprintf (numAlpha, "%d", numeroCasilla );
  string numero = numAlpha;
  aux = numero.substr ( 0, num );
  for ( int i = numero.size(); i<=num; i++ )
    aux += " ";
  string sNombreCorto = get_nombreCorto();
  aux += sNombreCorto.substr ( 0, nombreCorto );
  for ( int i = sNombreCorto.size (); i<=nombreCorto; i++ )
    aux += " ";
  string sTipo = "T";
  aux += sTipo.substr ( 0, tipo );
  for ( int i = sTipo.size (); i<=tipo; i++ )
    aux += " ";
  string sNombre = get_nombre();
  aux += sNombre.substr ( 0, nombre );
  for ( int i = sNombre.size (); i<=nombre; i++ )
    aux += " ";
  string sEstado = "-";
  aux += "-";
  for ( int i = sEstado.size (); i<=estado; i++ )
    aux += " ";
  return aux;
}

/**
 * Mtodos pblicos no virtuales
 */

/**
 * Mtodo bsico en los movimientos de los jugadores. Coloca un jugador en la casilla actual,
 * insertndolo al final del vector de jugadores.
 */
void casilla::situarJugadorEnCasilla ( jugador* player )
{
  estaJugador.push_back ( player );
}

/**
 * Caso contrario al anterior. Eliminar el jugador de la casilla actual. Buscar en el vector y lo
 * elminacin.
 * Consideracin: No se sabe en que posicin estar el jugador, pero habitualmente estar en la primera
 * ya que normalmente se mueve al jugador que lanza los dados, y ese ha debido ser el primero en llegar
 * all, pero no se puede asegurar, por lo que se realizar una bsqueda secuencial.
 */
void casilla::eliminarJugador ( jugador* player )
{  
  int i = 0;
  if ( estaJugador.size() > 0 )
    {
      while ( estaJugador[i] != player )
	i++;
      estaJugador.erase ( estaJugador.begin()+i );
    }
}

