

#include "casilla_tarjetas.h"

// Constructor por defecto
casilla_tarjetas::casilla_tarjetas ()
  : casilla ()
{
  // No se hace nada!
}

//Constructor explcito
casilla_tarjetas::casilla_tarjetas ( int numero, string nombre, string nombreCorto )
  : casilla ( numero, nombre, nombreCorto )
{
  // No se hace nada!
}

/**
 * Copy constructor
 */
casilla_tarjetas::casilla_tarjetas (const casilla_tarjetas& right)
{
  casilla casilla_tarjetas(right);	
  _mazoAsociado         = right.get_mazo();
}

/**
 * Opreador de asignacin
 */
casilla_tarjetas& casilla_tarjetas::operator= (const casilla_tarjetas& right)
{   
  casilla::operator= ( right );
  _mazoAsociado         = right.get_mazo();
  return ( *this );
}

// Destructor
casilla_tarjetas::~casilla_tarjetas ()
{
  // No se hace nada!
}

/**
 * Mtodos virtuales: Polimorfismo
 */

/** 
 * MTODOS PARA DIBUJAR LAS CASILLAS 
 */

/**
 * Mtodo que dibuja la fila indicada de la casilla correspondiente (en las filas de arriba y abajo del tablero).
 * Se indicar la fila que se tiene que dibujar y el ancho con el que se tiene que pintar. Como resultado se
 * devolver una cadena de caracteres.
 */
string casilla_tarjetas::dibujarCasillaHorizontal ( int fila, int anchoCasilla )
{
  string sFila;  
  
  switch ( fila )
    {
    case 0:
      sFila = " ";				//Primer caracter
      for ( int i = 1; i < anchoCasilla ; i++ )
	sFila += "_";
      break;

    case 1:					//numero + (monopolio, flecha o nada----------- )
      {
	char numAlpha[30];
	sprintf( numAlpha, "%d", get_numero() );
	sFila = string ( numAlpha );       
	while ( sFila.size() <= ( anchoCasilla - 3 ) )
	  sFila += " ";      
	sFila += "?|";
	break;
      }

    case 2:
      sFila = get_nombreCorto();
      while ( sFila.size() <= ( anchoCasilla - 2 ) )
	sFila += " ";      
      sFila += "|";
      break;

    case 3:					//COMPROBAR SI ESTAN LOS JUGADORES 1, 2 y 3
      {
	int i = 0;
	string aux = "";
	int numJugadores = estaJugador.size ();
	while ( ( numJugadores > 0 ) && ( i < numJugadores ) && ( i < 3 ) )
	  {
	    string color = estaJugador[i]->get_color();
	    string colorAbreviado = color.substr(0,2);
	    transform (colorAbreviado.begin(), colorAbreviado.end(), colorAbreviado.begin(), (int(*)(int))toupper);
	    aux += colorAbreviado;
	    //aux += color.substr(0,2); 
	    i++;
	    if ( i < 3 ) 
	      aux += " ";
	  }
	while (aux.size() < anchoCasilla - 1 )
	  aux += " ";
	sFila += aux + '|';
	break;
      }

    case 4:					//COMPROBAR SI ESTAN LOS JUGADORES 4, 5 y 6      
      {
	int i = 3;
	string aux = "";
	int numJugadores = estaJugador.size ();
	while ( ( numJugadores > 3 ) && ( i < numJugadores ) && ( i < 6 ) )
	  {	   
	    string color = estaJugador[i]->get_color();
	    string colorAbreviado = color.substr(0,2);
	    transform (colorAbreviado.begin(), colorAbreviado.end(), colorAbreviado.begin(), (int(*)(int))toupper);
	    aux += colorAbreviado;
	    //aux += color.substr(0,2);
	    i++;
	    if ( i < 6 ) 
	      aux += " ";	
	  }
	while (aux.size() < anchoCasilla - 1 )
	  aux += " ";
	sFila += aux + '|';
	break;
      }

    case 5:
      while ( sFila.size() <= ( anchoCasilla - 2 ) )
	sFila += "_";	 	
      sFila += "|";
      break;    
    }
  
  return sFila;
}

/**
 *  Mtodo que dibuja la fila indicada de la casilla correspondiente (en las columnas derecha e izquierda del tablero).
 *  -IN: fila: Fila que se tiene que dibujar
 *	numero: numero de la casilla
 *	anchoCasilla: el ancho de las casillas establecido
 *   -OUT: string: La fila dibujada.
 */
string casilla_tarjetas::dibujarCasillaVertical ( int fila, int anchoCasilla )
{
  string sFila;  
  
  sFila = "|";
  switch ( fila )
    {    

    case 0:					//numero + posibles jugadores 1, 2 y 3
      {
	string aux = "";
	char numAlpha[30];
	sprintf( numAlpha, "%d", get_numero() );
	aux += string ( numAlpha ) + " ?";
	if ( get_numero() < 10 )
	  aux +=  "   ";
	else aux +=  "  ";
	int i = 0;
	int numJugadores = estaJugador.size ();
	while ( ( numJugadores > 0 ) && ( i < numJugadores ) && ( i < 3 ) )
	  {
	    string color = estaJugador[i]->get_color();
	    string colorAbreviado = color.substr(0,2);
	    transform (colorAbreviado.begin(), colorAbreviado.end(), colorAbreviado.begin(), (int(*)(int))toupper);
	    aux += colorAbreviado;
	    //string color = estaJugador[i]->get_color();
	    //aux += color.substr(0,2);	    
	    i++;
	    if ( i < 3 ) 
	      aux += " ";	
	  }
	while (aux.size() < anchoCasilla - 1 )
	  aux += " ";
	sFila += aux + '|';      
	break;
      }
    case 1:
      {
	string aux = "";
	aux += get_nombreCorto();      
	while ( aux.size() < 6 ) aux += " ";
	int i = 3;	
	int numJugadores = estaJugador.size ();
	while ( ( numJugadores > 3 ) && ( i < numJugadores ) && ( i < 6 ) )
	  {
	    string color = estaJugador[i]->get_color();
	    string colorAbreviado = color.substr(0,2);
	    transform (colorAbreviado.begin(), colorAbreviado.end(), colorAbreviado.begin(), (int(*)(int))toupper);
	    aux += colorAbreviado;
	    //string color = estaJugador[i]->get_color();
	    //aux += color.substr(0,2);
	    i++;
	    if ( i < 6 ) 
	      aux += " ";	
	  }
	while (aux.size() < anchoCasilla - 1 )
	  aux += " ";
	sFila += aux + '|';
	break;
      }
      
    case 2:      
      while ( sFila.size() <= ( anchoCasilla - 1) )
	sFila += "_";      
      sFila += "|";
      break;  
      
      return sFila;
    }
}

/**
 * Devuelve la informacin de la casilla de tarjetas en modo texto para mostrar por pantalla la informacin
 * en forma de tabla. 
 */
string casilla_tarjetas::leyendaCasilla ( int num, int nombreCorto, int tipo, int nombre, int estado )
{
  string aux;
  int numeroCasilla = get_numero();
  char numAlpha[30];
  sprintf (numAlpha, "%d", numeroCasilla );
  string numero = numAlpha;
  aux = numero.substr ( 0, num );
  for ( int i = numero.size(); i<=num; i++ )
    aux += " ";
  string sNombreCorto = get_nombreCorto();
  aux += sNombreCorto.substr ( 0, nombreCorto );
  for ( int i = sNombreCorto.size (); i<=nombreCorto; i++ )
    aux += " ";
  string sTipo = "?";
  aux += sTipo.substr ( 0, tipo );
  for ( int i = sTipo.size (); i<=tipo; i++ )
    aux += " ";
  string sNombre = get_nombre();
  aux += sNombre.substr ( 0, nombre );
  for ( int i = sNombre.size (); i<=nombre; i++ )
    aux += " ";
  string sEstado = "-";
  aux += sEstado;
  for ( int i = sEstado.size (); i<=estado; i++ )
    aux += " ";
  return aux;
}

/**
 * Polimorfismo del mtodo accion de la clase base casilla. ste tipo de casilla tienen la
 * particularidad de ejecutar sus acciones a traves de las tarjetas de su mazo asociado, 
 * por lo que se remitir a ellas para ejecutar las acciones.
 */
int casilla_tarjetas::accion ( jugador *player )
{  
  return _mazoAsociado->cogerTarjeta ( player );
}

