/**********************************************************************************
							dado.cpp
	
Programa: 	7
Nombre:		Javier Aragn Zabalegui		100039831@alumnos.uc3m.es
Fecha_inicio:	30.Octubre.2005
Descripcion:	Clase dado para Street Master's
			
Comentarios:	
**********************************************************************************/

/**********************************************************************************
Listado de contenidos:
	include "dado.h"

**********************************************************************************/

#include "dado.h"

// Constructor por defecto
dado::dado ()
  : _dado1 ( 0 ),
    _dado2 ( 0 ),
    _dadoTotal ( 0 ),    
    _tiradaDoble ( false )
{
  //No se hace nada!!
}

// constructor explcito
dado::dado ( int dado1, int dado2 )
  : _dado1 ( dado1 ),
    _dado2  ( dado2 )
{
  //_dadoTotal es un atributo caluclado.
  set_dadoTotal ( dado1 + dado2 );
  //_tiradaDoble es un atributo calculado
  if ( dado1 == dado2 )
    set_tiradaDoble ( true );
  else
    set_tiradaDoble ( false );
}
 
// Copy constructor
dado::dado (const dado& right)
{
  _dado1	= right._dado1;
  _dado2 	= right._dado2;
  _dadoTotal  	= right._dadoTotal;
  _tiradaDoble = right._tiradaDoble;
}

// Assignment operator
dado& dado::operator= (const dado& right)
{
  _dado1	= right.get_dado1 ();
  _dado2	= right.get_dado2 ();
  _dadoTotal	= right.get_dadoTotal ();
  _tiradaDoble	= right.get_tiradaDoble ();
  return ( *this );
}

// Destructor
dado::~dado ()
{
  // No se hace nada!
}

/** 
 *  Mtodo que devuelve un nmero pseudoaleatorio entre 1 y 6. Con ello se pretende
 *  representar la tirada de un dado. 
 *  Para crear nmeros pseudoaleatorios se usa el algoritmo de Merssenne Twister que 
 *  es mucho ms efectivo que la funcin random() de C
 */
void dado::tirarDado()
{ 
  //Lanza dado 1 y se convierte el valor en positivo
  long aux = _irand ();
  if ( aux < 0 )
    aux = 0 - aux;
  //El dado debe ser un valor entre 1 y 6.
  set_dado1 ( ( aux % 6 ) + 1 );

  //Lanza dado 2 y se convierte el valor en positivo
  aux = _irand ();
  if ( aux < 0 )
    aux = 0 - aux;
  //El dado debe ser un valor entre 1 y 6
  set_dado2 ( ( aux % 6 ) + 1 );

  //Se asignan los atrinutos calculados
  set_dadoTotal ( get_dado1() + get_dado2() );
  if ( get_dado1() == get_dado2() )
    set_tiradaDoble( true );
  else
    set_tiradaDoble( false );
}
