/***********************************************************************************
 *  CLASE ENCARCELADORA
 *  Clase que representa la casilla de Monopoly que dice "A la crcel". Esta casilla
 *  encarcelar al jugador que caiga sobre ella.
 *
 *  Requiere:
 *     - clase jugador ( jerarquia )
 *     - clase algorithm (STL)
 *     - clase vector (STL)
 *     - clase string (STL)
 *
 *  Autor: Javier Aragn Zabalegui (PFC para la uc3m: street Master's)
 *  Contacto: 100039831@alumnos.uc3m.es
 *  version 1.0
 **********************************************************************************/


#ifndef __ENCARCELADORA__
#define __ENCARCELADORA__

#include "casilla.h"

#include <string>
using namespace std;

class encarceladora : public casilla {

 private:

  //Nada

 public:

  // Constructor por defecto
  encarceladora ();
  
  // Constructor explcito
  encarceladora ( int numero, string nombre, string nombreCorto );
  
  // Copy constructor
  encarceladora ( const encarceladora& right );

  // Operador de asignacin  
  encarceladora& operator= (const encarceladora& right);

  // Destructor
  ~encarceladora ();

  /**
   * Mtodo polimrfico de la clase casilla. En este caso el jugador ser enviado a la casilla
   * de tipo crcel del tablero.
   */
  int accion ( jugador* player );
};

#endif
