/**********************************************************************************
			estacion.cpp
	
Programa: 	28
Nombre:		Javier Aragn Zabalegui		100039831@alumnos.uc3m.es
Fecha_inicio:	14.Marzo.2005
Version:        0.01
Descripcion:	Clase estacion para Street Master's
			
Comentarios:	Hereda de propiedad
**********************************************************************************/

/**********************************************************************************
Listado de contenidos:
	include "estacion.h"

**********************************************************************************/

#include <iostream>
using namespace std;


#include "estacion.h"

// Constructor por defecto
estacion::estacion ()
  : propiedad (),
    _alquilerUnaEstacion ( 0 ),
    _alquilerDosEstaciones ( 0 ),
    _alquilerTresEstaciones ( 0 ),
    _alquilerCuatroEstaciones ( 0 )
{
  // No se hace nada!
}

// constructor explcito
estacion::estacion ( int numero, string nombre, string nombreCorto, long precio, long hipoteca, bool hipotecado, 
		     bool hipotecable, long alquilerUnaEstacion, long alquilerDosEstaciones, 
		     long alquilerTresEstaciones, long alquilerCuatroEstaciones, propietario *p )
  : propiedad ( numero, nombre, nombreCorto, precio, hipoteca, hipotecado, hipotecable, p ),
    _alquilerUnaEstacion ( alquilerUnaEstacion ),
    _alquilerDosEstaciones ( alquilerDosEstaciones ),
    _alquilerTresEstaciones ( alquilerTresEstaciones ),
    _alquilerCuatroEstaciones ( alquilerCuatroEstaciones )
{
  // No se hace nada!
}
 
// Copy constructor
estacion::estacion (const estacion& right)
{
  propiedad estacion(right);			
  _alquilerUnaEstacion		= right._alquilerUnaEstacion;
  _alquilerDosEstaciones	= right._alquilerDosEstaciones;
  _alquilerTresEstaciones	= right._alquilerTresEstaciones;
  _alquilerCuatroEstaciones	= right._alquilerCuatroEstaciones;
}

// Assignment operator
estacion& estacion::operator= (const estacion& right)
{  
  propiedad::operator= ( right );
  _alquilerUnaEstacion		= right._alquilerUnaEstacion;
  _alquilerDosEstaciones	= right._alquilerDosEstaciones;
  _alquilerTresEstaciones	= right._alquilerTresEstaciones;
  _alquilerCuatroEstaciones	= right._alquilerCuatroEstaciones;
  return ( *this );
}

// Sobrecarga del opereador de salida
ostream& operator<< ( ostream& os, estacion *e )
{
  os << "info estacion";
  return os;
}

// Destructor
estacion::~estacion ()
{
  // No se hace nada!
}


// POLIMORFISMOS

/**
 * Mtodo que devuelve en una cadena de caracteres toda la informacin necesaria, con un
 * formato preparado para mostrarse por pantalla, de una casilla de tipo estacin, que 
 * incluye:
 *    - Nombre
 *    - Nmero de casilla
 *    - Precio
 *    - Alquileres (todas las posibilidades)
 *    - Hipoteca 
 */
string estacion::mostrar ()
{  
  const int ancho = 42;
  string aux =  " __________________________________________\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += centrarCadena ( get_nombre(), ancho + 2, 2, "|" );

  // Muestra el propietario si lo tiene
  if ( jugador *j = dynamic_cast <jugador *> ( get_esPropiedad() ) )
    {
      if ( j != NULL )
	{
	  aux += "|                                          |";
	  if ( get_hipotecado() )
	    {
	      aux += "             PROPIETARIO: ";
	      aux += j->get_nombre() + " (" + j->get_color() + ")    HIPOTECADO\n";
	    }
	  else
	    {
	      aux += "             PROPIETARIO: ";
	      aux += j->get_nombre() + " (" + j->get_color() + ")\n";
	    }
	}
      else
	aux += "|                                          |\n"; 
    }
  else
    aux += "|                                          |\n";

  aux += "|                                          |\n";

  //Muestra los diferentes alquileres
  aux += centrarCadena ( "ALQUILER:", ancho + 2, 1, "|" );
  char precioAlpha[30];
  sprintf ( precioAlpha, "%d", get_alquilerUnaEstacion () );
  string aux2 = "Si tiene 1 estacin = " + string ( precioAlpha );
  aux += centrarCadena ( aux2, ancho + 2, 1, "|" );

  sprintf ( precioAlpha, "%d", get_alquilerDosEstaciones () );
  aux2 = "Si tiene 2 estaciones = " + string ( precioAlpha );
  aux += centrarCadena ( aux2, ancho + 2, 1, "|" );

  sprintf ( precioAlpha, "%d", get_alquilerTresEstaciones () );
  aux2 = "Si tiene 3 estaciones = " + string ( precioAlpha );
  aux += centrarCadena ( aux2, ancho + 2, 1, "|" );

  sprintf ( precioAlpha, "%d", get_alquilerCuatroEstaciones () );
  aux2 = "Si tiene 4 estaciones = " + string ( precioAlpha );
  aux += centrarCadena ( aux2, ancho + 2, 1, "|" );

  aux += "|                                          |\n";
  aux += "|                                          |\n";
 
  // Muestra el precio
  sprintf ( precioAlpha, "%d", get_precio () );
  aux2 = "Precio = " + string ( precioAlpha );
  aux += centrarCadena ( aux2, ancho + 2, 1, "|" );
 
  sprintf ( precioAlpha, "%d", get_hipoteca () );
  aux2 = "Hipoteca = " + string ( precioAlpha );
  aux += centrarCadena ( aux2, ancho + 2, 1, "|" );
 
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";

  //Nmero de casilla
  char numAlpha[10];
  sprintf ( numAlpha, "%d", get_numero() );
  if ( get_numero() >= 10 )
    aux += "|                                       " + string ( numAlpha )  + " |\n";
  else
    aux += "|                                        " + string ( numAlpha )  + " |\n";
  aux += centrarCadena ( verColor(), ancho + 2, 1, "|" );
  aux += "|__________________________________________|\n";
  return aux;  
}

/**
 * Mtodo que dibuja la fila indicada de la casilla correspondiente (en las filas de arriba y abajo del tablero).
 * Se indicar la fila que se tiene que dibujar y el ancho con el que se tiene que pintar. Como resultado se
 * devolver una cadena de caracteres.
 */
string estacion::dibujarCasillaHorizontal ( int fila, int anchoCasilla )
{
  string sFila;  
  const int MaxCasillasAncho = 13;
  
  switch ( fila )
    {
    // Parte superior del rectngulo (primera fila)
    case 0:
      sFila = " "; 
      for ( int i = 1; i < anchoCasilla ; i++ )
	sFila += "_";
      break;

    // Nmero de casilla e identificador de la estacin (E)
    case 1:
      {
	char numAlpha[10];
	sprintf( numAlpha, "%d", get_numero() );
	sFila = string ( numAlpha );       
	while ( sFila.size() <= ( anchoCasilla - 3 ) )
	  sFila += " ";	
	sFila += "E|";
	break;
      }

    // Nombre corto de la estacin y estado
    case 2:
      sFila = get_nombreCorto();
      if ( !dynamic_cast <jugador *> ( get_esPropiedad() ) )	
	sFila +="(L)";
      else
	sFila +="(C)";     

      while ( sFila.size() <= ( anchoCasilla - 2 ) )
	sFila += " ";      
      sFila += "|";
      break;

    // Jugadores que estn en la casilla (de 1 a 3)
    case 3:					
      {
	int i = 0;
	string aux = "";	
	int numJugadores = estaJugador.size ();
	while ( ( numJugadores > 0 ) && ( i < numJugadores ) && ( i < 3 ) )
	  {
	    string color = estaJugador[i]->get_color();
	    string colorAbreviado = color.substr(0,2);
	    //Convertir a maysculas
	    transform (colorAbreviado.begin(), colorAbreviado.end(), colorAbreviado.begin(), (int(*)(int))toupper);
	    aux += colorAbreviado;
	    //aux += color.substr(0,2); 
	    i++;
	    if ( i < 3 ) 
	      aux += " ";
	  }
	while (aux.size() < anchoCasilla - 1 )
	  aux += " ";
	sFila += aux + '|';
	break;
      }

    // Jugadores que estn en la casilla (de 4 a 6)
    case 4:      
      {
	int i = 3;
	string aux = "";	
	int numJugadores = estaJugador.size ();
	while ( ( numJugadores > 3 ) && ( i < numJugadores ) && ( i < 6 ) )
	  {	   
	    string color = estaJugador[i]->get_color();
	    string colorAbreviado = color.substr(0,2);
	    //Convertir a maysculas
	    transform (colorAbreviado.begin(), colorAbreviado.end(), colorAbreviado.begin(), (int(*)(int))toupper);
	    aux += colorAbreviado;	    
	    i++;
	    if ( i < 6 ) 
	      aux += " ";	
	  }	
	while (aux.size() < anchoCasilla - 1 )
	  aux += " ";
	sFila += aux + '|';
	break;
      }

    case 5:
      while ( sFila.size() <= ( anchoCasilla - 2 ) )
	sFila += "_";	 	
      sFila += "|";
      break;    
    }
  
  return sFila;
}

/**
 * Mtodo que dibuja la fila indicada de la casilla correspondiente (en las columnas derecha e izquierda del tablero).
 * Se indicar la fila que se tiene que dibujar y el ancho con el que se tiene que pintar. Como resultado se
 * devolver una cadena de caracteres.
 */
string estacion::dibujarCasillaVertical ( int fila, int anchoCasilla )
{
  string sFila;  
  int const MaxCasillasAncho = 13;
  int const MaxCasillasAlto = 8;
  
  sFila = "|";
  switch ( fila )
    {    

    // Nmero de casilla y los tres primeros jugadores que estn en la casilla.
    case 0: 
      {
	
	string aux = "";
	char numAlpha[30];
	sprintf( numAlpha, "%d", get_numero() );
	aux += string ( numAlpha );	
	aux += " E";
	if ( get_numero() < 10 )
	  aux +=  "  ";
	else 
	  aux += " ";
	int i = 0;
	int numJugadores = estaJugador.size ();
	while ( ( numJugadores > 0 ) && ( i < numJugadores ) && ( i < 3 ) )
	  {
	    string color = estaJugador[i]->get_color();
	    string colorAbreviado = color.substr(0,2);
	    // Convertir a maysculas el color de la ficha
	    transform (colorAbreviado.begin(), colorAbreviado.end(), colorAbreviado.begin(), (int(*)(int))toupper);
	    aux += colorAbreviado;	    
	    i++;
	    if ( i < 3 ) 
	      aux += " ";	
	  }
	while (aux.size() < anchoCasilla - 1 )
	  aux += " ";
	sFila += aux + '|';      
	break;
      }

    // Nombre corto y los ltimos jugadores que estn en la casilla si hay ms de 3
    case 1:
      {
	string aux = "";
	//Nombre corto
	aux += get_nombreCorto();

	//Estado de la casilla
	if ( ! dynamic_cast <jugador *> ( get_esPropiedad() ) )	  
	  aux +="(L)";
	else
	  aux +="(C)";     

	while ( aux.size() < 6 ) aux += " ";
	// Jugadores
	int i = 3;
	int numJugadores = estaJugador.size ();
	while ( ( numJugadores > 3 ) && ( i < numJugadores ) && ( i < 6 ) )
	  {
	    string color = estaJugador[i]->get_color();
	    aux += color.substr(0,2);
	    i++;
	    if ( i < 6 ) 
	      aux += " ";	
	  }	
	while (aux.size() < anchoCasilla - 1 )
	  aux += " ";
	sFila += aux + '|';
	break;
      }
      
    case 2:      
      while ( sFila.size() <= ( anchoCasilla - 1) )
	sFila += "_";      
      sFila += "|";
      break;  
      
      return sFila;
    }
}

/**
 * Devuelve la informacin de la casilla de impuesto especial en modo texto para mostrar por pantalla la informacin
 * en forma de tabla. 
 */
string estacion::leyendaCasilla ( int num, int nombreCorto, int tipo, int nombre, int estado )
{
  string aux;
  
  // Numero de casilla
  int numeroCasilla = get_numero();
  char numAlpha[30];
  sprintf (numAlpha, "%d", numeroCasilla );
  string numero = numAlpha;
  aux = numero.substr ( 0, num );
  for ( int i = numero.size(); i<=num; i++ )
    aux += " ";

  // Nombre corto
  string sNombreCorto = get_nombreCorto();
  aux += sNombreCorto.substr ( 0, nombreCorto );
  for ( int i = sNombreCorto.size (); i<=nombreCorto; i++ )
    aux += " ";

  // Identificador de tipo de casilla
  string sTipo = "E";
  aux += sTipo.substr ( 0, tipo );
  for ( int i = sTipo.size (); i<=tipo; i++ )
    aux += " ";

  // Nombre
  string sNombre = get_nombre();
  aux += sNombre.substr ( 0, nombre );
  for ( int i = sNombre.size (); i<=nombre; i++ )
    aux += " ";  
  
  //Estado de la estacion
  string sEstado;
  if ( ! dynamic_cast <jugador *> ( get_esPropiedad() ) )
    //if ( get_esPropiedad() == NULL )
    sEstado += "L";
  else
    sEstado +="C";     
  aux += sEstado;
  for ( int i = sEstado.size (); i<=estado; i++ )
    aux += " ";
  return aux;
}

/**
 * Polimorfismo de la clase propiedad. 
 * Mtodo que obtiene el alquiler en funcin del nmero de estaciones que posee el propietario
 * de esta instancia de la clase estacin.
 */
long estacion::calcularAlquiler ( jugador *j )
{  
  monopolio *mp = get_perteneceMonopolio();
  int numEstaciones = mp->contarPropiedadesConMismoPropietario ( this );
  int precio = 0;
  switch ( numEstaciones )
      {
      case 1:
	precio = get_alquilerUnaEstacion ();
	break;
      case 2:
	precio = get_alquilerDosEstaciones ();
	break;
      case 3:
	precio = get_alquilerTresEstaciones ();
	break;
      case 4:
	precio = get_alquilerCuatroEstaciones ();
	  break;
      default:
	precio = get_alquilerUnaEstacion() * numEstaciones;
      }
  return precio;
}
