/**********************************************************************************
				impuesto.cpp
	
Programa: 	11
Nombre:		Javier Aragn Zabalegui		100039831@alumnos.uc3m.es
Fecha_inicio:	3.Noviembre.2005
Descripcion:	Clase impuesto para Street Master's
			
Comentarios:	Hereda de casilla
**********************************************************************************/

/**********************************************************************************
Listado de contenidos:
	include "propiedad.h"

**********************************************************************************/

#include "impuesto.h"

// Constructor por defecto
impuesto::impuesto ()
  : casilla (),
  _cantidad ( 20000 )
{
  // No se hace nada!
}

// constructor explcito
impuesto::impuesto ( int numero, string nombre, string nombreCorto, int cantidad  )
  : casilla ( numero, nombre, nombreCorto ),
    _cantidad ( cantidad )
{
  // No se hace nada!
}
 
// Copy constructor
impuesto::impuesto (const impuesto& right):casilla( right )
{  
  _cantidad 	= right._cantidad;  
}

// Assignment operator
impuesto& impuesto::operator= (const impuesto& right)
{  
  casilla::operator= ( right );
  _cantidad	= right.get_cantidad ();
  return ( *this );
}

// Destructor
impuesto::~impuesto ()
{
  // No se hace nada!
}

/**
 * Mtodo que devuelve en una cadena de caracteres toda la informacin necesaria, con un
 * formato preparado para mostrarse por pantalla, de una casilla de tipo impuesto, que 
 * incluye:
 *    - Nombre
 *    - Nmero de casilla
 *    - Cantidad a pagar
 */
string impuesto::mostrar ()
{  
  const int ancho = 42;
  string aux =  " __________________________________________\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += centrarCadena ( get_nombre(), ancho + 2, 2, "|" ); 
  aux += "|                                          |\n"; 
  
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
 
  char precioAlpha[30];
  sprintf ( precioAlpha, "%d", get_cantidad () );
  string aux2 = "Pagar " + string ( precioAlpha );
  aux += centrarCadena ( aux2, ancho + 2, 1, "|" );
 
  aux += "|                                          |\n"; 
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  char numAlpha[10];
  sprintf ( numAlpha, "%d", get_numero() );
  if ( get_numero() >= 10 )
    aux += "|                                       " + string ( numAlpha )  + " |\n";
  else
    aux += "|                                        " + string ( numAlpha )  + " |\n";
  aux += "|                                          |\n";
  aux += "|__________________________________________|\n";
  return aux;
  //...Aqu como se muestra una casilla
}

 /**
  * Polimorfismo de la clase casilla. En este caso el jugador debe pagar la cantidad de
  * dinero que se indica en el atributo _cantidad de esta clase. En caso de no tener 
  * suficiente dinero, el jugador pasar a ser moroso.
  */
int impuesto::accion ( jugador* player )
{
  int opcionEjecutada;
  bool fin = true;
 
  int tamano = estaJugador.size();  
  cout << endl;
  
  string nombre = player->get_nombre();  
  
  cout << nombre;
  cout << " debes pagar " << get_cantidad () << " a la banca a modo de impuesto, por haber caido en la casilla ";
  cout << get_nombre() << endl;

  // Se descuenta al jugador la cantidad marcada en el atributo _cantidad
  int ok = player->pagar( get_cantidad () );  
  
  return ( 0 );
}

// MTODOS PARA DIBUJAR LAS CASILLAS

/**
 * Mtodo que dibuja la fila indicada de la casilla correspondiente (en las filas de arriba y abajo del tablero).
 * Se indicar la fila que se tiene que dibujar y el ancho con el que se tiene que pintar. Como resultado se
 * devolver una cadena de caracteres.
 */
string impuesto::dibujarCasillaHorizontal ( int fila, int anchoCasilla )
{
  string sFila;  
  
  switch ( fila )
    {
    // Primera fila
    case 0:
      sFila = " ";
      for ( int i = 1; i < anchoCasilla ; i++ )
	sFila += "_";
      break;
    
    // Nmero de casilla e identificador
    case 1:
      {
	char numAlpha[10];
	sprintf( numAlpha, "%d", get_numero() );
	sFila = string ( numAlpha );       
	while ( sFila.size() <= ( anchoCasilla - 3 ) )
	  sFila += " ";      
	sFila += "$|";
	break;
      }

    // Nombre corto
    case 2:
      sFila = get_nombreCorto();
      while ( sFila.size() <= ( anchoCasilla - 2 ) )
	sFila += " ";      
      sFila += "|";
      break;

    // Muestra los jugadores que estn en la casilla
    case 3:
      {
	int i = 0;
	string aux = "";	
	int numJugadores = estaJugador.size ();
	while ( ( numJugadores > 0 ) && ( i < numJugadores ) && ( i < 3 ) )
	  {
	    string color = estaJugador[i]->get_color();
	    string colorAbreviado = color.substr(0,2);
	    transform (colorAbreviado.begin(), colorAbreviado.end(), colorAbreviado.begin(), (int(*)(int))toupper);
	    aux += colorAbreviado;
	    i++;
	    if ( i < 3 ) 
	      aux += " ";
	  }
	while (aux.size() < anchoCasilla - 1 )
	  aux += " ";
	sFila += aux + '|';
	break;
      }

    // Muestra los jugadores que estn en la casilla
    case 4:
      {
	int i = 3;
	string aux = "";
	int numJugadores = estaJugador.size ();
	while ( ( numJugadores > 3 ) && ( i < numJugadores ) && ( i < 6 ) )
	  {	   
	    string color = estaJugador[i]->get_color();
	    string colorAbreviado = color.substr(0,2);
	    transform (colorAbreviado.begin(), colorAbreviado.end(), colorAbreviado.begin(), (int(*)(int))toupper);
	    aux += colorAbreviado;
	    i++;
	    if ( i < 6 ) 
	      aux += " ";	
	  }
	while (aux.size() < anchoCasilla - 1 )
	  aux += " ";
	sFila += aux + '|';
	break;
      }

    case 5:
      while ( sFila.size() <= ( anchoCasilla - 2 ) )
	sFila += "_";	 	
      sFila += "|";
      break;    
    }
  
  return sFila;
}

/**
 * Mtodo que dibuja la fila indicada de la casilla correspondiente (en las columnas derecha e izquierda del tablero).
 * Se indicar la fila que se tiene que dibujar y el ancho con el que se tiene que pintar. Como resultado se
 * devolver una cadena de caracteres.
 */
string impuesto::dibujarCasillaVertical ( int fila, int anchoCasilla )
{
  string sFila;  
  
  sFila = "|";
  switch ( fila )
    {    
    // Nmero de casilla, identificador y jugadores
    case 0:
      {
	string aux = "";
	char numAlpha[10];
	sprintf( numAlpha, "%d", get_numero() );
	aux += string ( numAlpha ) + " $";
	if ( get_numero() < 10 )
	  aux +=  "   ";
	else aux +=  "  ";
	int i = 0;	
	
	//Jugadores que estn en esta casilla
	int numJugadores = estaJugador.size ();
	while ( ( numJugadores > 0 ) && ( i < numJugadores ) && ( i < 3 ) )
	  {
	    string color = estaJugador[i]->get_color();
	    aux += color.substr(0,2);	    
	    i++;
	    if ( i < 3 ) 
	      aux += " ";	
	  }
	while (aux.size() < anchoCasilla - 1 )
	  aux += " ";
	sFila += aux + '|';      
	break;
      }

    // Nombre corto y jugadores que estan en la casilla.
    case 1:
      {
	string aux = "";
	aux += get_nombreCorto();      
	while ( aux.size() < 6 ) aux += " ";
	int i = 3;	
	int numJugadores = estaJugador.size ();
	while ( ( numJugadores > 3 ) && ( i < numJugadores ) && ( i < 6 ) )
	  {
	    string color = estaJugador[i]->get_color();
	    aux += color.substr(0,2);
	    i++;
	    if ( i < 6 ) 
	      aux += " ";	
	  }
	while (aux.size() < anchoCasilla - 1 )
	  aux += " ";
	sFila += aux + '|';
	break;
      }
      
    case 2:      
      while ( sFila.size() <= ( anchoCasilla - 1) )
	sFila += "_";      
      sFila += "|";
      break;  
      
      return sFila;
    }
}

/**
 * Mtodo que devuelve una cadena de caracteres que representa como es la casilla en su 
 * imgen en el tablero, indicando aquellos datos de inters para un jugador que caiga 
 * sobre ella:
 *  -Numero
 *  -Nombre
 *  -Impuesto fijo
 */
string impuesto::dibujarCasillaEnTablero ()
{
  const int anchoDibujado = 27;
  string aux;
  aux = " ___________________________\n";
  aux +="|                           |\n";
  aux +="|                           |\n";  
  
  // Linea del nombre 
  string linea = "|";
  string nombre = get_nombre ();
  aux += centrarCadena ( nombre, anchoDibujado + 2, 2, "|" );

  // Información sobre la edificación en la calle 
  aux +="|                           |\n";
  aux +="|                           |\n";
  aux +="|                           |\n";

  // Precio de la propiedad 
  string precio = "Pagar ";
  char precioAlpha[30];
  sprintf( precioAlpha, "%d", get_cantidad() );
  precio += precioAlpha;
  aux += centrarCadena ( precio, anchoDibujado + 2, 1, "|" );

  // Número de casilla 
  int numero = get_numero();
  aux +="|                         ";
  if ( numero < 10 )
    aux += " ";
  char numAlpha[10];
  sprintf( numAlpha, "%d", numero );
  aux += numAlpha;
  aux += "|\n";

  // Base del rectángulo 
  aux +="|___________________________|\n";
  return aux;
}

/**
 * Devuelve la informacin de la casilla de impuesto en modo texto para mostrar por pantalla la informacin
 * en forma de tabla. 
 */
string impuesto::leyendaCasilla ( int num, int nombreCorto, int tipo, int nombre, int estado )
{
  string aux;
  
  //Numero de casilla
  int numeroCasilla = get_numero();
  char numAlpha[30];
  sprintf (numAlpha, "%d", numeroCasilla );
  string numero = numAlpha;
  aux = numero.substr ( 0, num );
  for ( int i = numero.size(); i<=num; i++ )
    aux += " ";

  //Nombre corto
  string sNombreCorto = get_nombreCorto();
  aux += sNombreCorto.substr ( 0, nombreCorto );
  for ( int i = sNombreCorto.size (); i<=nombreCorto; i++ )
    aux += " ";

  //Tipo
  string sTipo = "$";
  aux += sTipo.substr ( 0, tipo );
  for ( int i = sTipo.size (); i<=tipo; i++ )
    aux += " ";

  //Nombre de la casilla
  string sNombre = get_nombre();
  aux += sNombre.substr ( 0, nombre );
  for ( int i = sNombre.size (); i<=nombre; i++ )
    aux += " ";

  //Estado de la casilla
  string sEstado = "-";
  aux += sEstado;
  for ( int i = sEstado.size (); i<=estado; i++ )
    aux += " ";
  return aux;
}

