/**********************************************************************************
				impuesto.cpp
	
Programa: 	13
Nombre:		Javier Aragn Zabalegui		100039831@alumnos.uc3m.es
Fecha_inicio:	3.Noviembre.2005
Descripcion:	Clase impuesto5 para Street Master's. Representa la casilla 5 del 
		monopoly.
			
Comentarios:	Hereda de impuesto, que a su vez hereda de casilla
**********************************************************************************/

/**********************************************************************************
Listado de contenidos:
	include "impuesto5.h"

**********************************************************************************/

#include "impuesto5.h"

// Constructor por defecto
impuesto5::impuesto5 ()
  : impuesto (),
  _tpc (15)
{
  // No se hace nada!
}

// constructor explcito
impuesto5::impuesto5 ( int numero, string nombre, string nombreCorto, int cantidad, int tpc )
  : impuesto ( numero, nombre, nombreCorto, cantidad ),
    _tpc ( tpc )
{
  // No se hace nada!
}
 
// Copy constructor
impuesto5::impuesto5 (const impuesto5& right):impuesto ( right )
{
  _tpc		= right._tpc;
}

// Assignment operator
impuesto5& impuesto5::operator= (const impuesto5& right)
{  
  impuesto::operator= ( right );  
  _tpc		= right.get_tpc ();
  return ( *this );
}

// Destructor
impuesto5::~impuesto5 ()
{
  // No se hace nada!
}

/**
 * Mtodo que devuelve en una cadena de caracteres toda la informacin necesaria, con un
 * formato preparado para mostrarse por pantalle,  de una casilla de tipo impuesto5, que 
 * incluye:
 *    - Nombre
 *    - Nmero de casilla
 *    - Cantidad a pagar
 *    - Porcentaje 
 */
string impuesto5::mostrar ()
{  
  const int ancho = 42;
  string aux =  " __________________________________________\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += centrarCadena ( get_nombre(), ancho + 2, 2, "|" ); 
  aux += "|                                          |\n"; 
  
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";
   
  aux += centrarCadena ( "PAGAR", ancho + 2, 1, "|" );

  //Cantidad a pagar
  char precioAlpha[30]; 
  sprintf ( precioAlpha, "%d", get_cantidad () );

  //Porcentaje a pagar
  char tpcAlpha[30];
  sprintf ( tpcAlpha, "%d", get_tpc () );
  string aux2 = string ( tpcAlpha ) + "%  " + string ( precioAlpha );
  aux += centrarCadena ( aux2, ancho + 2, 1, "|" );
  aux += "|                                          |\n"; 
  aux += "|                                          |\n";
  aux += "|                                          |\n";
  aux += "|                                          |\n";

  //Nmero de casilla
  char numAlpha[30];
  sprintf ( numAlpha, "%d", get_numero() );
  if ( get_numero() >= 10 )
    aux += "|                                       " + string ( numAlpha )  + " |\n";
  else
    aux += "|                                        " + string ( numAlpha )  + " |\n";

  //Cerrar la caja
  aux += "|                                          |\n";
  aux += "|__________________________________________|\n";
  return aux;  
}

/**
 * Polimorfismo de la clase casilla. En este caso se preguntar al jugador si desea pagar
 * la cantidad fija que hereda de la clase impuesto o prefiere pagar un tanto por ciento del
 * capital calculado a partir del capital del jugador (player) y el porcentaje que se indica
 * en el atributo _tpc de esta misma clase.
 */
int impuesto5::accion ( jugador *player )
{
  int opcionEjecutada;
  bool fin = true;

  // Imprimir men de opciones que el jugador puede elegir (porcentaje o cantidad)
  int tamano = estaJugador.size();
  
  cout << endl;  
  string nombre = player->get_nombre();    
  cout << nombre;
  cout << " debes pagar " << get_cantidad () << " o el " << get_tpc () << "% de tu capital a la banca a modo de impuesto, por haber caido en la casilla ";  
  cout << get_nombre() << endl;
  cout << "-Selecciona la opcin de pago que vas a efectuar" << endl;
  cout << "\t(C) - Cantidad fija: " << get_cantidad() << endl;
  cout << "\t(P) - " << get_tpc() << "% de tu capital" << endl;
  cout << "Opcion:";
  //Se obtiene la accin elegida
  char opcionPago = player->decidirImpuestoEspecial ( get_cantidad (), get_tpc () );
  
  //Se calcula la cantidad que se tiene que pagar
  int cantidad;
  if ( toupper ( opcionPago ) == 'C' )
    cantidad = get_cantidad();
  else
    cantidad = player->get_capital () * get_tpc () / 100;
  
  //El jugador paga la cantidad seleccionada
  cout << "Debes pagar " << cantidad << " a la banca." << endl;  
  player->pagar( cantidad );
  return ( 0 );
}


// MTODOS PARA DIBUJAR CASILLAS

/**
 * Mtodo que dibuja la fila indicada de la casilla correspondiente (en las filas de arriba y abajo del tablero).
 * Se indicar la fila que se tiene que dibujar y el ancho con el que se tiene que pintar. Como resultado se
 * devolver una cadena de caracteres.
 */
string impuesto5::dibujarCasillaHorizontal ( int fila, int anchoCasilla )
{
  string sFila;  
  
  // Algo diferente por cada fila a dibujar
  switch ( fila )
    {
    case 0:                                     //Se pinta la linea superior
      sFila = " ";				//Primer caracter
      for ( int i = 1; i < anchoCasilla ; i++ )
	sFila += "_";
      break;
    // Dibujar el numero de casilla y el identificador de tipo
    case 1:
      {
	char numAlpha[30];
	sprintf( numAlpha, "%d", get_numero() );
	sFila = string ( numAlpha );
	while ( sFila.size() <= ( anchoCasilla - 4 ) )
	  sFila += " ";      
	sFila += "%$|";
	break;
      }

    // Escribir el nombre corto
    case 2:
      sFila = get_nombreCorto();
      while ( sFila.size() <= ( anchoCasilla - 2 ) )
	sFila += " ";      
      sFila += "|";
      break;

    // Indicar que jugadores estan en la casilla
    case 3:	
      {
	int i = 0;
	string aux = "";	
	int numJugadores = estaJugador.size ();
	while ( ( numJugadores > 0 ) && ( i < numJugadores ) && ( i < 3 ) )
	  {
	    string color = estaJugador[i]->get_color();
	    string colorAbreviado = color.substr(0,2);
	    transform (colorAbreviado.begin(), colorAbreviado.end(), colorAbreviado.begin(), (int(*)(int))toupper);
	    aux += colorAbreviado;
	    //aux += color.substr(0,2); 
	    i++;
	    if ( i < 3 ) 
	      aux += " ";
	  }
	while (aux.size() < anchoCasilla - 1 )
	  aux += " ";
	sFila += aux + '|';
	break;
      }

    // Indicar que jugadores estn en la casilla
    case 4:					     
      {
	int i = 3;
	string aux = "";
	int numJugadores = estaJugador.size ();
	while ( ( numJugadores > 3 ) && ( i < numJugadores ) && ( i < 6 ) )
	  {	   
	    string color = estaJugador[i]->get_color();
	    string colorAbreviado = color.substr(0,2);
	    transform (colorAbreviado.begin(), colorAbreviado.end(), colorAbreviado.begin(), (int(*)(int))toupper);
	    aux += colorAbreviado;
	    //aux += color.substr(0,2);
	    i++;
	    if ( i < 6 ) 
	      aux += " ";	
	  }
	while (aux.size() < anchoCasilla - 1 )
	  aux += " ";
	sFila += aux + '|';
	break;
      }

    case 5:
      while ( sFila.size() <= ( anchoCasilla - 2 ) )
	sFila += "_";	 	
      sFila += "|";
      break;    
    }
  
  return sFila;
}

/**
 * Mtodo que dibuja la fila indicada de la casilla correspondiente (en las columnas derecha e izquierda del tablero).
 * Se indicar la fila que se tiene que dibujar y el ancho con el que se tiene que pintar. Como resultado se
 * devolver una cadena de caracteres.
 */
string impuesto5::dibujarCasillaVertical ( int fila, int anchoCasilla )
{
  string sFila;  
  
  sFila = "|";
  switch ( fila )
    {    
    // Nmero de casilla y posibles jugadores
    case 0:				       
      {
	string aux = "";
	char numAlpha[30];
	sprintf( numAlpha, "%d", get_numero() );
	aux += string ( numAlpha ) + " %$";
	if ( get_numero() < 10 )
	  aux +=  "  ";
	else aux +=  " ";
	int i = 0;	
	
	int numJugadores = estaJugador.size ();
	while ( ( numJugadores > 0 ) && ( i < numJugadores ) && ( i < 3 ) )
	  {
	    string color = estaJugador[i]->get_color();
	    aux += color.substr(0,2);	    
	    i++;
	    if ( i < 3 ) 
	      aux += " ";	
	  }
	while (aux.size() < anchoCasilla - 1 )
	  aux += " ";
	sFila += aux + '|';      
	break;
      }
    // Nombre corto y posibles jugadores
    case 1:
      {
	string aux = "";
	aux += get_nombreCorto();      
	while ( aux.size() < 6 ) aux += " ";
	int i = 3;	
	int numJugadores = estaJugador.size ();
	while ( ( numJugadores > 3 ) && ( i < numJugadores ) && ( i < 6 ) )
	  {
	    string color = estaJugador[i]->get_color();
	    aux += color.substr(0,2);
	    i++;
	    if ( i < 6 ) 
	      aux += " ";	
	  }
	while (aux.size() < anchoCasilla - 1 )
	  aux += " ";
	sFila += aux + '|';
	break;
      }
    
    case 2:      
      while ( sFila.size() <= ( anchoCasilla - 1) )
	sFila += "_";      
      sFila += "|";
      break;  
      
      return sFila;
    }
}

/**
 * Mtodo que devuelve una cadena de caracteres que representa como es la casilla en su 
 * imgen en el tablero, indicando aquellos datos de inters para un jugador que caiga 
 * sobre ella:
 *  -Numero
 *  -Nombre
 *  -Impuesto fijo
 *  -Porcentaje
 */
string impuesto5::dibujarCasillaEnTablero ()
{
  const int anchoDibujado = 27;
  string aux;
  aux = " ___________________________\n";
  aux +="|                           |\n";
  aux +="|                           |\n";  
  
  // Linea del nombre
  string linea = "|";
  string nombre = get_nombre ();
  aux += centrarCadena ( nombre, anchoDibujado + 2, 2, "|" );

  aux +="|                           |\n";
  aux +="|                           |\n";

  // Literal "PAGAR"
  aux += centrarCadena ( "Pagar", anchoDibujado + 2, 1, "|" );

  // Cantidad a pagar
  char porcentajeAlpha[30];
  sprintf( porcentajeAlpha, "%d", get_tpc() );
  char precioAlpha[30];
  sprintf( precioAlpha, "%d", get_cantidad() );
  string precio = porcentajeAlpha;
  precio += "%  ";
  precio += precioAlpha;
  aux += centrarCadena ( precio, anchoDibujado + 2, 1, "|" );

  // Nmero de casilla
  int numero = get_numero();
  aux +="|                         ";
  if ( numero < 10 )
    aux += " ";
  char numAlpha[30];
  sprintf( numAlpha, "%d", numero );
  aux += numAlpha;
  aux += "|\n";

  // Base del rectangulo
  aux +="|___________________________|\n";
  return aux;
}

/**
 * Devuelve la informacin de la casilla de impuesto especial en modo texto para mostrar por pantalla la informacin
 * en forma de tabla. 
 */
string impuesto5::leyendaCasilla ( int num, int nombreCorto, int tipo, int nombre, int estado )
{
  string aux;
  
  //Nmero de casilla
  int numeroCasilla = get_numero();
  char numAlpha[30];
  sprintf (numAlpha, "%d", numeroCasilla );
  string numero = numAlpha;
  aux = numero.substr ( 0, num );
  for ( int i = numero.size(); i<=num; i++ )
    aux += " ";

  //Nombre corto
  string sNombreCorto = get_nombreCorto();
  aux += sNombreCorto.substr ( 0, nombreCorto );
  for ( int i = sNombreCorto.size (); i<=nombreCorto; i++ )
    aux += " ";

  //Icono de impuesto especial
  string sTipo = "%$";
  aux += sTipo.substr ( 0, tipo );
  for ( int i = sTipo.size (); i<=tipo; i++ )
    aux += " ";

  //Nombre de la casilla
  string sNombre = get_nombre();
  aux += sNombre.substr ( 0, nombre );
  for ( int i = sNombre.size (); i<=nombre; i++ )
    aux += " ";

  //Estado actual. Siempre '-'
  string sEstado = "-";
  aux += sEstado;
  for ( int i = sEstado.size (); i<=estado; i++ )
    aux += " ";
  return aux;
}
