
#include "mazo.h"

// Constructor por defecto
mazo::mazo ()
  : _nombre ( "" )
{

  // No se hace nada!
}

// constructor explcito
mazo::mazo ( string nombre )
  : _nombre ( nombre )
{

}
 
// Copy constructor
mazo::mazo (const mazo& right)
{
  _nombre	= right._nombre;
}

// Assignment operator
mazo& mazo::operator= (const mazo& right)
{
  _nombre	= right._nombre;
  return ( *this );
}

// Destructor
mazo::~mazo ()
{
  // No se hace nada!
}

/**
 * Mtodo que carga las tarjetas de un mazo desde el fichero indicado
 */
int mazo::cargar_tarjetas ( string ficheroTarjetas, string tipo )
{
  string nombre = "";
  int numero = 0,pay = 0, advance = 0, advanceto = 0, payeach = 0, payhouse = 0, payhotel = 0, multiPago =1, multiPagoDado = 0;
  bool nextutil = false, tojail = false, nextrr = false, jailcard = false, cobrarSalida = true, nextPropiedad= false;

  int ok;
  bool error = false;
  bool finTarjeta = false;
  bool nuevaTarjeta = true;
  bool finAccion = false;
  int numTarjs = 0;

  fstream ifs ( ficheroTarjetas.c_str (), ios::in );
  if ( !ifs )
    {
      cerr << "Fichero de tablero no disponible. Compruebe que exista " << ficheroTarjetas << endl;
      return -1;
    }

  //leer datos del fichero
  const int N=200;
  string linea;
  int ncars=0, i, cont_linea = 0;
  do
    {
      cont_linea++;
      getline ( ifs, linea, '\n' );     //lee una linea
      if ( ifs.eof() ) break;		//fin de fichero      
      /* Tratamos la linea leida */
      /* Elimina espacios en blanco y comentarios de una linea */
      i=0;
      while ( ( linea[i] != '#') && (i < linea.size () ) )
	i++;	 
      /* Limpia los comentarios detectados y los espacios en blanco */      
      
      linea = linea.substr ( 0, i );
      linea = stripwhite_st ( linea );


      if ( linea.size() > 0 )
	{
	  if ( linea.substr ( linea.size() - 1, linea.size() )  == ";" )
	    {
	      finTarjeta = true;
	      numTarjs ++;
	      finAccion = true;
	      linea = linea.substr ( 0, linea.size() - 1 );
	      linea = stripwhite_st ( linea );
	    }
	  string::size_type posAccion = linea.find( "ACCION", 0 );
	  if ( posAccion != string::npos )
	    {
	      finAccion = true;
	      linea = linea.substr ( posAccion + 6, linea.size() );
	      linea = stripwhite_st ( linea );
	    }
	  else if ( linea.substr(0,1) == "[" )
	    nombre = linea.substr ( 1, linea.size() - 2);
	  else 
	    {
	      string::size_type posicion  = linea.find( "=", 0 );

	      //Si no ha llegado al final de fichero
	      if ( posicion != string::npos )
		{

		  //Lee los diferentes atributos de la accin
		  string etiqueta = linea.substr( 0, posicion );
		  etiqueta = stripwhite_st ( etiqueta );
		  string valor = linea.substr ( posicion + 1, linea.size() );
		  valor = stripwhite_st ( valor );
		  if ( etiqueta == "numero")
		    if ( nuevaTarjeta == true )
		      numero = atoi ( valor.c_str () );
		    else
		      {
			cerr << "ERROR: Nmero de tarjeta "<< numero << " duplicado. Revise el fichero de tarjetas " << ficheroTarjetas << endl;
			cerr << "No se ha podido crear la partida" << endl;
			return -1;
		      }
		  else if ( etiqueta == "sgtServicio")		
		    nextutil = atoi ( valor.c_str () );
		  else if ( etiqueta == "encarcelar" )
		    tojail = atoi ( valor.c_str () );
		  else if ( etiqueta == "avanzarA" )
		    advanceto = atoi ( valor.c_str () );
		  else if ( etiqueta == "avanzar" )
		    advance = atoi ( valor.c_str () );
		  else if ( etiqueta == "pagar" )
		    pay = atoi ( valor.c_str () );
		  else if ( etiqueta == "sgtEstacion" )
		    nextrr = atoi ( valor.c_str () );
		  else if ( etiqueta == "tarjetaCarcel" )
		    jailcard = atoi ( valor.c_str () );
		  else if ( etiqueta == "pagarPorCasa" )
		    payhouse = atoi ( valor.c_str () );
		  else if ( etiqueta == "pagarPorHotel" )
		    payhotel = atoi ( valor.c_str () );
		  else if ( etiqueta == "pagarATodos" )
		    payeach = atoi ( valor.c_str () );
		  else if ( etiqueta == "multiPago" )
		    multiPago = atoi ( valor.c_str () );		  
		  else if ( etiqueta == "cobrarSalida" )
		    cobrarSalida = atoi ( valor.c_str () );
		  else if ( etiqueta == "multiPagoDado" )
		    multiPagoDado = atoi ( valor.c_str () );
		  else if ( etiqueta == "sgtPropiedad" )
		    nextPropiedad = atoi ( valor.c_str () );
		}
	    }
	}    
      if ( ( ncars = ifs.gcount() ) == N-1 ) //se activo el failbit
	ifs.clear();
      if ( ( finTarjeta == true ) || ( finAccion == true ) )
	{
	  //Si se inserta una nueva tarjeta, hay que crearla
	  if ( nuevaTarjeta == true )
	    {
	      if ( existeTarjeta ( numero ) )
		{
		  cout << "ERROR: Nmero de tarjeta repetido: " << numero << endl;
		  return -1;
		}
	      ok = anyadirTarjeta ( nombre, numero, tipo );
	      nuevaTarjeta = false;
	    }
	  else{
	    //Si no, se aade la accin
	    ok = anyadirAccion ( numero, pay, advance, advanceto, payeach, 
				 payhouse, payhotel, multiPago, nextutil, tojail, nextrr, 
				 jailcard, cobrarSalida, multiPagoDado, nextPropiedad );	    
	  }
	  if ( ok == -1 )
	    {
	      cerr << "Error al insertar la tarjeta cerca de la linea " << cont_linea << " del fichero " << ficheroTarjetas << endl;
	      cerr << "Qu desea hacer? (O)mitir (C)ancelar ";
	      char opcion = getchar ();	  
	      if ( toupper(opcion) != 'O' )
		return -1;
	      cin.clear(); //limpio las banderas de cin. Colocarlas en estado de bueno
	      cin.ignore( 2000, '\n' ); // vacia el buffer de la entrada ya que contiene "basura
	    }
	  if ( finTarjeta == true )
	    {
	      ok = 0;
	      finTarjeta = false;
	      nuevaTarjeta = true;
	      nombre = "";
	      numero = -1;
	    }
	  //Inicializa los valores
	  finAccion = false;
	  pay = 0;
	  advance = 0;
	  advanceto = -1;
	  payeach = 0;
	  payhouse = 0;
	  payhotel = 0;
	  multiPago = 1;
	  bool nextutil = false;
	  tojail = false;
	  nextrr = false;
	  jailcard = false;	  
	  cobrarSalida = true;
	  multiPagoDado = 0;
	}      
    } while ( true );    
  return ok;
}

/**
 * Se genera una posicin aleatoria en la que insertar la tarjeta actual y se colocar
 * en dicha posicin simulando un barajeo de cartas.
 */
int mazo::anyadirTarjeta ( string nombre, int numero, string tipo )
{
  tarjeta *tjt = new tarjeta ( numero, nombre, true, tipo );

  //Si es la primera tarjeta se inserta al principio
  if ( _contiene.size() == 0 )
    _contiene.push_back ( tjt );
  // Acceso aleatorio para insertar la tarjeta
  else //Acceso aleatorio
    {
      long tiempo = unsigned(time(NULL));
      // Generador de entero de 32 bits
      MTRand_int32 irand( tiempo ); 
      //Se calcula la posicin en la lista
      int posicion = irand() % _contiene.size ();      
      _contiene.insert ( _contiene.begin() +  posicion, tjt );
    }
  return 0;
}

/**
 * Se aade una accin a una tarjeta ya creada que contenga los datos pasados como parmetro.
 * Se aadir al final de la lista de acciones.
 */
int mazo::anyadirAccion ( int numero, int pay, int advance, int advanceto, int payeach, 
			  int payhouse, int payhotel, int multiPago, bool nextutil, bool tojail,
			  bool nextrr, bool jailcard, bool cobrarSalida, int multiPagoDado, bool nextPropiedad )
{
  int ok = 0;
  int i = 0;
  //Busca la tarjeta en la que se debe insertar
  while ( ( i < _contiene.size() ) && ( numero != _contiene[i] -> get_numero() ) )
    i++;
  if ( i < _contiene.size() )
    //Incluye la accin
    _contiene[i] -> incluirAccion ( pay, advance, advanceto, payeach, payhouse, payhotel, 
				    multiPago, nextutil, tojail, nextrr, jailcard, 
				    cobrarSalida, multiPagoDado, nextPropiedad );
  else 
    ok = -1;

  return ok;  
}

/**
 * Comprueba que exista una tarjeta con un nmero dado (identificativo) en el mazo
 */
bool mazo::existeTarjeta ( int numero )
{
  bool existe = false;
  deque <tarjeta*>::iterator i; 
  for ( i = _contiene.begin(); i != _contiene.end(); i++ )
    if ( (*i)->get_numero() == numero )
      existe = true;
  return ( existe );
}

/**
 * El jugador actual recoge la tarjeta del mazo y se invocar a la accin de la tarjeta.
 * La instancia de la tarjeta se encargar de gestionar la accin
 */
int mazo::cogerTarjeta ( jugador *j )
{
  //Si hay tarjetas para coger, la coge y ejecuta la accin
  //Se elimina de la cima del mazo y se coloca al final del mismo
  if ( ! _contiene.empty() )
    {
      tarjeta *tjt = _contiene[0];
      _contiene.erase( _contiene.begin() );
      
      cout << tjt;  
      int ejecucion = tjt->ejecutar( j );
      if ( ejecucion != 1 )
	{
	  _contiene.push_back ( tjt );
	}
    }
  else
    cout << "No quedan tarjetas para coger" << endl;
  return 0;
}

/**
 * El jugador devuelve la tarjeta al mazo en el caso de que se trate de una tarjeta de crcel que
 * el jugador s puede poseer. Se coloca al final del mismo.
 */
int mazo::devolverTarjeta ( jugador *j )
{
  tarjeta *tjt = j->devuelveTarjeta ();
  tjt->set_disponible ( true );
  _contiene.push_back ( tjt );
  return 0;
}

/**
 * Devuelve la tarjeta del mazo que se indica con el nmero que se pasa como argumento del mtodo
 */
tarjeta *mazo::obtenerTarjeta ( int numero )
{
  deque <tarjeta*>::iterator i; 
  i = _contiene.begin();
  while ( ( (*i)->get_numero() != numero ) && ( i != _contiene.end () ) )
    i++;
  if ( (*i)->get_numero() == numero )
    return (*i);
  return ( NULL );
}

/**
 * Elimina del mazo la tarjeta identificada por el nmero pasado como argumento
 */
int mazo::eliminarTarjeta ( int numero )
{
  deque <tarjeta*>::iterator i; 
  i = _contiene.begin();
  while ( ( (*i)->get_numero() != numero ) && ( i != _contiene.end () ) )
    i++;
  if ( (*i)->get_numero() == numero )
    {
      _contiene.erase ( i );
      return ( 0 );
    }
  return ( -1 );
}
