#include "propietario.h"
#include "propiedad.h"
#include "calle.h"

propietario::propietario()  
{
  //No se hace nada
}

propietario::propietario ( list<propiedad*> posee )
  : _posee ( posee )
{
  //No se hace nada
}

/**
 * Copy constructor
 */
propietario::propietario (const propietario& right)
{
  _posee	= right._posee;
}

/**
 * Operador de asignacin
 */
propietario& propietario::operator= (const propietario& right)
{
  _posee	= right._posee;
  return ( *this );
}

/**
 * Destructor
 */
propietario::~propietario ()
{
  // no se hace nada
}

/**
 * Comrpueba si el propietario tiene la propiedad identificada por el nmero pasado como argumento
 * del mtodo
 */
bool propietario::tienePropiedadInt ( int numero )
{
  list <propiedad*>::iterator p; 
  bool cierto = false;
  //Recorrer toda la lista comprobando el atributo nmero de la propiedad
  for ( p = _posee.begin(); p != _posee.end(); p++ )
    {
      if ( (*p)->get_numero () == numero )
	cierto = true;
    }
  return cierto;
}

/**
 * Se obtiene la propiedad del propietario cuyo numero coincide con el que se pasa como argumento
 */
propiedad *propietario::get_propiedad ( int numero )
{
  propiedad *prop = NULL;
  list <propiedad*>::iterator p; 
  //Recorre la lista hasta encontrar la que se desea
  for ( p = _posee.begin(); p != _posee.end(); p++ )
    {
      if ( (*p)->get_numero () == numero )
	{
	  prop = (*p);
	}
    }
  //Si no se encuentra devuelve NULL. Si se encuentra la devuelve
  return prop;
}

/**
 * Aade una lista completa de propiedades al propietario. Se aadir una a una cada propiedad.
 */
void propietario::anyadirListaPropiedades ( list <propiedad*> listaPropiedades )
{
  list <propiedad*>::iterator listaP;

  // Se recorre la lista aadiendo propiedades al propietario
  for ( listaP = listaPropiedades.begin(); listaP != listaPropiedades.end(); listaP++ )    
    {
      (*listaP)->set_esPropiedad ( this );      
      set_posee ( *listaP );
      if ( calle *c = dynamic_cast<calle *> ( *listaP ) )
	{
	  monopolio *mp = c->get_perteneceMonopolio ();
	  if ( mp->construible () )
	    mp->permitirConstruir();
	  else
	    mp->prohibirConstruir ();
	}
    }
  return;
}

/**
 * Elimina una propiedad dada de las posesiones del propietario.
 */
void propietario::eliminarPropiedad ( propiedad *p )
{
  list <propiedad*>::iterator listaP; 
  listaP = _posee.begin ();
  //Busca la propiedad
  while ( (*listaP) != p )    
    listaP ++;
  //La elimina de la lista
  _posee.erase ( listaP );
}

/**
 * Elimina las coincidencias de la lista dada de la lista de propiedades del propietario
 */
void propietario::eliminarListaPropiedades ( list <propiedad*> listaPropiedades )
{
  list <propiedad*>::iterator listaP; 
  for ( listaP = listaPropiedades.begin(); listaP != listaPropiedades.end(); listaP++ )        
    {
      eliminarPropiedad ( *listaP );    
    }
  return;
}

