/**********************************************************************************
				salida.cpp
	
Programa: 	13
Nombre:		Javier Aragn Zabalegui		100039831@alumnos.uc3m.es
Fecha_inicio:	4.Noviembre.2005
Descripcion:	Clase salida para Street Master's
			
Comentarios:	Hereda de casilla
**********************************************************************************/

/**********************************************************************************
Listado de contenidos:
	include "salida.h"

**********************************************************************************/

#include "salida.h"

// Constructor por defecto
salida::salida ()
  : casilla (),
  _sueldo ( 20000 )
{
  // No se hace nada!
}

// constructor explcito
salida::salida ( int numero, string nombre, string nombreCorto, long sueldo  )
  : casilla ( numero, nombre, nombreCorto ),
    _sueldo ( sueldo )
{
  // No se hace nada!
}
 
// Copy constructor
salida::salida (const salida& right):casilla ( right )
{
  _sueldo 	= right._sueldo;  
}

// Assignment operator
salida& salida::operator= (const salida& right)
{  
  casilla::operator= ( right );
  _sueldo = right.get_sueldo ();
  return ( *this );
}

// Destructor
salida::~salida ()
{
  // No se hace nada!
}

/**
 * Polimorfismo de la clase casilla. En el caso de las casilla se debe pagar al 
 * jugador la cantidad de dinero que se indica en el atributo _sueldo.
 */
int salida::accion ( jugador* player )
{
  // Se paga al jugador la cantidad indicada en _sueldo
  player->pagar ( 0 - get_sueldo () );
  cout << player->get_nombre () << " cobras " << get_sueldo () << " por pasar por la casilla de salida." << endl;
  //Devuelve 0, indica que la accion ha ocurrido correctamente.
  return 0;
}

/**
 * Mtodo que dibuja la fila indicada de la casilla correspondiente (en las filas de arriba y abajo del tablero).
 * Se indicar la fila que se tiene que dibujar y el ancho con el que se tiene que pintar. Como resultado se
 * devolver una cadena de caracteres.
 */
string salida::dibujarCasillaHorizontal ( int fila, int anchoCasilla )
{
  string sFila;  
  const int MaxCasillasAncho = 13;
  
  switch ( fila )
    {

    // Primera fila del rectangulo
    case 0:
      sFila = " ";				//Primer caracter
      for ( int i = 1; i < anchoCasilla ; i++ )
	sFila += "_";
      break;
    
    // Nmero de casilla y flecha que indica la direccin de juego
    case 1:
      {
	char numAlpha[10];
	sprintf( numAlpha, "%d", get_numero() );
	sFila = string ( numAlpha );       
	while ( sFila.size() <= ( anchoCasilla - 4 ) )
	  sFila += " ";
	if ( get_numero() <= MaxCasillasAncho )
	  sFila += "->";
	else
	  sFila += "<-";
	sFila += "|";
	break;
      }

    // Nombre corto de la casilla de salida
    case 2:
      sFila = get_nombreCorto();
      while ( sFila.size() <= ( anchoCasilla - 2 ) )
	sFila += " ";      
      sFila += "|";
      break;

    // Los tres primeros jugadores que se encuentran en la casilla
    case 3:
      {
	int i = 0;
	string aux = "";	
	int numJugadores = estaJugador.size ();

	//Recorre los tres primers elementos de la lista de jugadores
	while ( ( numJugadores > 0 ) && ( i < numJugadores ) && ( i < 3 ) )
	  {	    
	    string color = estaJugador[i]->get_color();
	    string colorAbreviado = color.substr(0,2);

	    //Convierte a mayusculas
	    transform (colorAbreviado.begin(), colorAbreviado.end(), colorAbreviado.begin(), (int(*)(int))toupper);
	    aux += colorAbreviado;	    
	    i++;
	    if ( i < 3 ) 
	      aux += " ";
	  }
	while (aux.size() < anchoCasilla - 1 )
	  aux += " ";
	sFila += aux + '|';
	break;
      }

    // Si hay ms de tres jugadores, seguir pintandolos
    case 4:
      {
	int i = 3;
	string aux = "";	
	int numJugadores = estaJugador.size ();

	//Recorre la lista desde el tercer jugador
	while ( ( numJugadores > 3 ) && ( i < numJugadores ) && ( i < 6 ) )
	  {	   
	    string color = estaJugador[i]->get_color();
	    string colorAbreviado = color.substr(0,2);
	    
	    // Color abreviado en mayusculas
	    transform (colorAbreviado.begin(), colorAbreviado.end(), colorAbreviado.begin(), (int(*)(int))toupper);
	    aux += colorAbreviado;	    
	    i++;
	    if ( i < 6 ) 
	      aux += " ";	
	  }	
	while (aux.size() < anchoCasilla - 1 )
	  aux += " ";
	sFila += aux + '|';
	break;
      }

    case 5:
      while ( sFila.size() <= ( anchoCasilla - 2 ) )
	sFila += "_";	 	
      sFila += "|";
      break;    
    }
  
  return sFila;
}

/**
 * Mtodo que dibuja la fila indicada de la casilla correspondiente (en las columnas derecha e izquierda del tablero).
 * Se indicar la fila que se tiene que dibujar y el ancho con el que se tiene que pintar. Como resultado se
 * devolver una cadena de caracteres.
 */
string salida::dibujarCasillaVertical ( int fila, int anchoCasilla )
{
  string sFila;  
  int const MaxCasillasAncho = 13;
  int const MaxCasillasAlto = 8;

  sFila = "|";
  switch ( fila )
    {    
    // Dibujar el nmero de casilla y los tres primeros jugadores que esten en la casilla
    case 0:
      {	
	string aux = "";
	char numAlpha[30];
	sprintf( numAlpha, "%d", get_numero() );

	//Numero de casilla
	aux += string ( numAlpha );
	if ( get_numero () <= MaxCasillasAncho + MaxCasillasAlto )
	  aux += " v";
	else 
	  aux += " ^";
	if ( get_numero() < 10 )
	  aux +=  "   ";
	else aux +=  "  ";
	int i = 0;
	
	// Mostrar los jugadores
	int numJugadores = estaJugador.size ();
	while ( ( numJugadores > 0 ) && ( i < numJugadores ) && ( i < 3 ) )
	  {
	    string color = estaJugador[i]->get_color();
	    aux += color.substr(0,2);	    
	    i++;
	    if ( i < 3 ) 
	      aux += " ";	
	  }
	while (aux.size() < anchoCasilla - 1 )
	  aux += " ";
	sFila += aux + '|';      
	break;
      }
    
    // Nombre corto y los siguientes jugadores si los hay
    case 1:
      {
	string aux = "";
	aux += get_nombreCorto();      
	while ( aux.size() < 6 ) aux += " ";
	int i = 3;	
	int numJugadores = estaJugador.size ();
	while ( ( numJugadores > 3 ) && ( i < numJugadores ) && ( i < 6 ) )
	  {
	    string color = estaJugador[i]->get_color();
	    aux += color.substr(0,2);
	    i++;
	    if ( i < 6 ) 
	      aux += " ";	
	  }	
	while (aux.size() < anchoCasilla - 1 )
	  aux += " ";
	sFila += aux + '|';
	break;
      }
      
    case 2:      
      while ( sFila.size() <= ( anchoCasilla - 1) )
	sFila += "_";      
      sFila += "|";
      break;  
      
      return sFila;
    }
}

/**
 * Mtodo que devuelve una cadena de caracteres que representa como es la casilla en su 
 * imgen en el tablero, indicando aquellos datos de inters para un jugador que caiga 
 * sobre ella:
 *  -Numero
 *  -Nombre
 *  -Sueldo
 */
string salida::dibujarCasillaEnTablero ()
{
  const int anchoDibujado = 27;
  string aux;
  aux = " ___________________________\n";
  aux +="|                           |\n";
  aux +="|                           |\n";

  // Nombre
  aux += centrarCadena ( get_nombre(), anchoDibujado + 2, 2, "|" );
  
  // Sueldo
  char sueldoAlpha[30];
  sprintf ( sueldoAlpha, "%d", get_sueldo() );
  string sueldo = "Cobre ";
  sueldo += sueldoAlpha;
  aux += centrarCadena ( sueldo, anchoDibujado + 2, 1, "|" );
  aux += centrarCadena ( "cada vez que", anchoDibujado + 2, 1, "|" );
  aux += centrarCadena ( "pase por aqu", anchoDibujado + 2, 1, "|" );
  aux +="|                           |\n";
  
  //Numero
  int numero = get_numero();
  aux +="|     ==============>     ";
  if ( numero < 10 )
    aux += " ";
  char numAlpha[20];
  sprintf( numAlpha, "%d", numero );
  aux += numAlpha;
  aux += "|\n";

  aux +="|___________________________|\n";
  return aux;
}

/**
 * Devuelve la informacin de la casilla de salida en modo texto para mostrar por pantalla la informacin
 * en forma de tabla. 
 */
string salida::leyendaCasilla ( int num, int nombreCorto, int tipo, int nombre, int estado )
{
  string aux;
  
  // Numero de casilla
  int numeroCasilla = get_numero();
  char numAlpha[30];
  sprintf (numAlpha, "%d", numeroCasilla );
  string numero = numAlpha;
  aux = numero.substr ( 0, num );
  for ( int i = numero.size(); i<=num; i++ )
    aux += " ";
  
  // Nombre corto
  string sNombreCorto = get_nombreCorto();
  aux += sNombreCorto.substr ( 0, nombreCorto );
  for ( int i = sNombreCorto.size (); i<=nombreCorto; i++ )
    aux += " ";

  // Icono de tipo. En este caso es una flecha
  string sTipo = "->";
  aux += sTipo.substr ( 0, tipo );
  for ( int i = sTipo.size (); i<=tipo; i++ )
    aux += " ";

  // Nombre
  string sNombre = get_nombre();
  aux += sNombre.substr ( 0, nombre );
  for ( int i = sNombre.size (); i<=nombre; i++ )
    aux += " ";

  // Estado de la casilla. En este caso siempre '-'
  string sEstado = "-";
  aux += sEstado;

  for ( int i = sEstado.size (); i<=estado; i++ )
    aux += " ";

  return aux;
}
